//
// Copyright (c) 2022 Arm Limited
// SPDX-License-Identifier: MIT

#ifndef ELROND_H
#define ELROND_H

// generated by cmake
#include <elrond/gen_config.h>

#include <stdint.h>
#include <vspace/vspace.h>
#include <vka/vka.h>
#include <vka/capops.h>
#include <sel4utils/thread.h>
#include <sel4utils/vspace.h>
#include <sel4utils/elf.h>
#include <sel4utils/helpers.h>

#include <elrond_ep.h>
#include <elrond_shared.h>


// default configuration options
#define ELROND_DEFAULT_CSPACE_SIZE  CONFIG_ELROND_DEFAULT_CSPACE_SIZE
#define ELROND_DEFAULT_STACK_SIZE   CONFIG_ELROND_DEFAULT_STACK_SIZE
#define ELROND_DEFAULT_HEAP_SIZE    CONFIG_ELROND_DEFAULT_HEAP_SIZE
#define ELROND_DEFAULT_PRIORITY     CONFIG_ELROND_DEFAULT_PRIORITY

// limits of seL4 badges
#define ELROND_NTFN_MASK        0x8000000000000000UL
#define ELROND_CALL_MAX         0x7fffffffffffffffUL
#define ELROND_NTFN_MAX         63UL
#define ELROND_CALL_BADGE(x)    ((x) + 1)
#define ELROND_NTFN_BADGE(x)    (ELROND_NTFN_MASK | (((seL4_Word)1) << (x)))
#define ELROND_WAKEUP_BADGE     0x8000000000000000UL
#define ELROND_NULL_BADGE       0x0000000000000000UL

// predefined capability slots
enum elrond_slots {
    ELROND_CAP_NULL             = 0,
    ELROND_CAP_MAIN_TCB         = 1,
    ELROND_CAP_ASID_POOL        = 2,
    ELROND_CAP_CSPACE_ROOT      = 3,
    ELROND_CAP_VSPACE_ROOT      = 4,
    ELROND_CAP_FAULT_EP         = 5,
    ELROND_CAP_MAIN_CALL_EP     = 6,
    ELROND_CAP_MAIN_NTFN_EP     = 7,
    ELROND_RESERVED_CAP_COUNT   = 8,
};


// elrond state
typedef struct elrond_env {
    const char *pattern;
    const char *var;
} elrond_env_t;

enum elrond_type {
    ELROND_TYPE_INLINED,
    ELROND_TYPE_DATA,
    ELROND_TYPE_CAP,
    ELROND_TYPE_BADGED,
    ELROND_TYPE_EP,
    ELROND_TYPE_SHARED,
    ELROND_TYPE_CAP_COUNT,
};

typedef struct elrond_info {
    const char *pattern;
    const char *name;
    size_t size;
    enum elrond_type type;
    union {
        seL4_Word word;
        uint8_t bytes[sizeof(seL4_Word)];
        const uint8_t *data;
        seL4_CPtr cap;
        struct {
            seL4_CPtr cap;
            seL4_Word badge;
        } badged;
        elrond_shared_t *shared;
        elrond_ep_t *ep;
    } u;
} elrond_info_t;

typedef struct elrond_process {
    // name, elf, endpoint
    const char *name;
    elf_t elf;

    // configuration
    size_t cspace_size;
    size_t stack_size;
    size_t heap_size;
    uint8_t priority;

    // NOTE these are NOT null terminated
    const char **argv;
    size_t arg_count;
    const char **envp;
    size_t env_count;
    const elrond_info_t *infos;
    size_t info_count;

    // sel4 state
    sel4utils_thread_t main_thread;
    seL4_CPtr asid_pool;
    seL4_CPtr cspace_root;
    seL4_Word cspace_guard;
    size_t cap_count;
    seL4_CPtr vspace_root;
    sel4utils_alloc_data_t vspace_data;
    vspace_t vspace;
    uintptr_t heap;
    seL4_CPtr fault_ep;
    seL4_CPtr main_call_ep;
    seL4_CPtr main_ntfn_ep;
    size_t main_call_count;
    size_t main_ntfn_count;

    // elf symbols/headers
    uintptr_t entry_point;
    uintptr_t sysinfo;
    Elf_Phdr *elf_phdrs;
    size_t elf_phdr_count;
} elrond_process_t;

typedef struct elrond {
    // sel4 allocators
    vka_t *vka;
    vspace_t *vspace;
    seL4_CPtr tcb;
    seL4_CPtr asid_pool;

    // arrays of configuration info
    elrond_env_t *envs;
    size_t env_count;
    size_t env_capacity;
    elrond_info_t *infos;
    size_t info_count;
    size_t info_capacity;

    // active processes
    elrond_process_t **processs;
    size_t process_count;
    size_t process_capacity;
} elrond_t;


// create an elrond instance
int elrond_create(elrond_t *elrond,
        vka_t *vka,
        vspace_t *vspace,
        seL4_CPtr tcb,
        seL4_CPtr asid_pool);

#ifdef CONFIG_ELROND_BOOTSTRAP
// bootstrap the root task of a system and create an elrond instance
//
// note that vka and vspace allocators can be accessed through elrond_vka
// and elrond_vspace
int elrond_bootstrap(elrond_t *elrond, const char *root_name);
#endif


// some state access
static inline vka_t *elrond_vka(elrond_t *elrond) {
    return elrond->vka;
}

static inline vspace_t *elrond_vspace(elrond_t *elrond) {
    return elrond->vspace;
}

static inline seL4_CPtr elrond_tcb(elrond_t *elrond) {
    return elrond->tcb;
}

static inline seL4_CPtr elrond_asid_pool(elrond_t *elrond) {
    return elrond->asid_pool;
}


// optional overrideable configurations
int elrond_add_cspace_size(elrond_t *elrond, const char *pattern,
        size_t cspace_size);
int elrond_add_stack_size(elrond_t *elrond, const char *pattern,
        size_t stack_size);
int elrond_add_heap_size(elrond_t *elrond, const char *pattern,
        size_t heap_size);
int elrond_add_priority(elrond_t *elrond, const char *pattern,
        uint8_t priority);

// overridable environment variables
int elrond_add_env(elrond_t *elrond, const char *pattern,
        const char *key, const char *val);

// overridable extra info loaded before init
int elrond_add_info(elrond_t *elrond, const char *pattern,
        const char *name, const void *data, size_t size);
int elrond_add_cap(elrond_t *elrond, const char *pattern,
        const char *name, seL4_CPtr cap);
int elrond_add_badged(elrond_t *elrond, const char *pattern,
        const char *name, seL4_CPtr cap, seL4_Word badge);

// add shared memory or pages
//
// - pages here can actually be NULL, and any entry can be seL4_CapNull, these
//   will be backed by new zeroed pages allowing you to just configure the
//   attributes or leave holes in the pages
// - if init_data is NULL, the memory will be zeroed
// - if vaddr is not NULL, the resuling memory will be mapped
//   into the root process's vspace and returned there
int elrond_add_shared(elrond_t *elrond, const char *pattern,
        const char *name, size_t size, const void *init_data,
        void **vaddr);
int elrond_add_pages(elrond_t *elrond, const char *pattern,
        const char *name, size_t size,
        const seL4_CPtr *pages, size_t page_size,
        seL4_CapRights_t rights, bool cacheable,
        void **vaddr);

// add endpoints or calls/notifications/wakeups on a given endpoint
//
// - if ep is NULL, the resulting endpoints will be seL4_CapNull
// - if cap is not NULL, the resulting badged cap will be minted
//   into the root process's cspace and returned there
int elrond_add_ep(elrond_t *elrond, const char *pattern,
        const char *name, elrond_ep_t **ep);
int elrond_add_call(elrond_t *elrond, const char *pattern,
        const char *name, elrond_ep_t *ep, seL4_CPtr *cap);
int elrond_add_ntfn(elrond_t *elrond, const char *pattern,
        const char *name, elrond_ep_t *ep, seL4_CPtr *cap);
int elrond_add_wakeup(elrond_t *elrond, const char *pattern,
        const char *name, elrond_ep_t *ep, seL4_CPtr *cap);

// spawn a process
int elrond_spawn(elrond_t *elrond,
        const char *name, const void *elf, size_t elf_size);
int elrond_spawnv(elrond_t *elrond,
        const char *name, const void *elf, size_t elf_size,
        const char **argv);
int elrond_spawnl(elrond_t *elrond,
        const char *name, const void *elf, size_t elf_size,
        const char *arg0, ...);

// this is for debugging
void elrond_debugdump(elrond_t *elrond, const char *indent);

// yeah, this include is in a bit of a weird place
#include <elrond_process.h>


#endif
